#define INCL_DOSSEMAPHORES /* Include semaphore services */
#define INCL_DOSPROCESS    /* Include thread stuff... /*
#include <os2.h>

int hSharedDataFile;
HEV hev;

VOID CopyRecords1(ULONG uLong) {
   int hDataFile1 = OpenDataFile("datafile.1");

   DosWaitEventSem(hev, /* Wait for the other thread */
                   SEM_INDEFINITE_WAIT);
   /* The other thread is done at this point. This */
   /* thread now has exclusive access to the file. */
   while (!eof(hDataFile1)) {
      /* Read record from hDataFile1 */
      /* Write record to shared data file */
   }
   CloseDataFile(hDataFile1);
}

VOID CopyRecords2(ULONG uLong) {
   int hDataFile2 = OpenDataFile("datafile.2");

   /* Since the other thread is waiting, this   */
   /* thread gets exclusive access to the file. */
   while (!eof(hDataFile2)) {
      /* Read record from hDataFile2 */
      /* Write record to shared data file */
   }
   CloseDataFile(hDataFile2);
   DosPostEventSem(hev); /* This thread is done.     */
                         /* Tell the world about it. */
}

main() {
   TID atid[2];

   hSharedDataFile = OpenDataFile("datafile.shr");
   DosCreateEventSem(NULL,   /* Anonymous event */
                     &hev,
                     0,      /* Private event */
                     FALSE); /* Initially unowned */
   DosCreateThread(&atid[0], CopyRecords1, ...);
   DosCreateThread(&atid[1], CopyRecords2, ...);
   DosWaitThread(&atid[0], DCWW_WAIT); /* Wait for threads */
   DosCloseEventSem(hev); /* Close the event */
   CloseDataFile(hSharedDataFile);
}
